#include <stdio.h>

double hornerA(double a[], int n, int t) {
  double res = 0.0;
  int i;

  /* Verzija 1
  */
  t *= t;
  for (i = 3 * ((n-2) / 3) + 1; i >= 1; i -= 3)
    res = res * t + a[i];

  /* Verzija 2
  for (i = (n-2) / 3; i >= 0; --i)
    res = res * t * t + a[3 * i + 1];
  */

  return res;
}

double maxA(double a[], unsigned n, int x, int y) {
  int pot = 1, t, first = 1;
  double p, res;

  if (x > y) {
    int temp = x; x = y; y = temp;
  }

  while ((t = pot + 7) <= y) { /* u zadatku nije specificirano, pa moze i <y */
    if (t < x) continue; /* ide <=x, ako u while ide <x */
    p = hornerA(a, n, t);
    printf("  p(%d) = %g\n", t, p);
    if (first || p > res) {
      res = p;
      first = 0;
    }
    pot *= 3;
  }

  return (first ? -2 : res);
}

double hornerB(double t, double x, double y, int n) {
  double res = 0.0, pot = 1.0, ai;
  int j;

  t *= t;
  for (j = 0; j < n; ++j) {
    ai = pot + y;
    res = res * t + ai;
    pot *= x;
  }

  return res;
}

double maxB(double b[], unsigned n, int x, int y) {
  double res;
  int i;

  for (i = 0; i < n; ++i) {
    double p = hornerB(b[i], x, y, n);
    printf("  p(%g) = %g\n", b[i], p);
    if (!i || p > res) res = p;
  }

  return res;
}

double hornerC(int a[], int n, double t) {
  double res = 0.0;
  int i;
  
  for (i = 1 - n%2 ; i < n; i += 2)
    res = res * t + a[i];
  res *= t*t*t*t*t;

  return res;
}

double minC(int a[], unsigned n, double x, double y) {
  int k = 1, first = 1;
  double fakt = 1; /* može biti i long -- izbor između raspona (double ide do cca 10^308) i preciznosti (long pamti 4 znamenke vise) */
  double t, p, res;

  if (x > y) {
    int temp = x; x = y; y = temp;
  }

  while ((t = fakt - 17.19) <= y) { /* u zadatku nije specificirano, pa moze i <y */
    fakt *= k++;
    if (t < x) continue; /* ide <=x, ako u while ide <x */
    p = hornerC(a, n, t);
    printf("  p(%g) = %g\n", t, p);
    if (first || p < res) {
      res = p;
      first = 0;
    }
  }

  return (first ? -1 : res);
}

double hornerD(double t, int x, int n) {
  double res = 0.0;
  unsigned long fakt = 1.0;
  int j;

  for (j = 0; j < n; ++j) {
    unsigned long tmp = (fakt *= (j+1)) + x, ai = 1;
    while (tmp > 1) {
      tmp /= 2;
      ai *= 2;
    }
    res = res * t + ai;
  }

  return res * t;
}

double minD(double b[], unsigned m, int n, int x) {
  double res;
  int i;

  for (i = 0; i < m; ++i) {
    double p = hornerD(b[i], x, n);
    printf("  p(%g) = %g\n", b[i], p);
    if (!i || p < res) res = p;
  }

  return res;
}

int main(void) {
  double aA[] = { 0.2, 0.3, 0.5, 0.7, 1.1, 2.3, 1.9, 1.7, 1.3 };
  unsigned nA = sizeof(aA) / sizeof(double);
  int xA = 0, yA = 31;
  double resA;

  double bB[] = { 0.2, 0.3, 0.5, 0.7, 1.1, 2.3, 1.9, 1.7, 1.3 };
  unsigned nB = sizeof(bB) / sizeof(double);
  int xB = 2, yB = 3;
  double resB;

  int aC[] = { 2, 3, 5, 7, 11, 23, 19, 17, 13 };
  unsigned nC = sizeof(aC) / sizeof(int);
  int xC = -13, yC = 531;
  double resC;

  double bD[] = { 0.2, 0.3, 0.5, 0.7, 1.1, 2.3, 1.9, 1.7, 1.3 };
  unsigned mD = sizeof(bD) / sizeof(double);
  int xD = 2, nD = 7;
  double resD;

  int i;

  printf("Grupa A:\n");
  resA = maxA(aA, nA, xA, yA);
  printf("  max({");
  for (i = 0; i < nA; ++i) {
    if (i) printf(", ");
    printf("%g", aA[i]);
  }
  printf("}, %u, %d, %d) = %g\n", nA, xA, yA, resA);

  printf("Grupa B:\n");
  resB = maxB(bB, nB, xB, yB);
  printf("  max({");
  for (i = 0; i < nB; ++i) {
    if (i) printf(", ");
    printf("%g", bB[i]);
  }
  printf("}, %u, %d, %d) = %g\n", nB, xB, yB, resB);

  printf("Grupa C:\n");
  resC = minC(aC, nC, xC, yC);
  printf("  min({");
  for (i = 0; i < nC; ++i) {
    if (i) printf(", ");
    printf("%d", aC[i]);
  }
  printf("}, %u, %d, %d) = %g\n", nC, xC, yC, resC);

  printf("Grupa D:\n");
  resD = minD(bD, mD, nD, xD);
  printf("  min({");
  for (i = 0; i < mD; ++i) {
    if (i) printf(", ");
    printf("%g", bD[i]);
  }
  printf("}, %u, %d, %d) = %g\n", mD, nD, xD, resD);

  return 0;
}
