#include <stdio.h>

// ---------------------------------------------------------------------------------------------------------- Grupa A
int sumaProstihFaktora( int broj )
{
	int faktor = 2, suma = 0;
	
	while( broj > 1 )
	{
		if( broj % faktor == 0 )
		{
			suma += faktor;
			while( broj % faktor == 0 )
				broj /= faktor;
		}
		
		++faktor;
	}
	
	return suma;
}

void grupaA( int a[], int n, int s, int *element, int *index )
{
	int lo = 0, hi = n-1, mid, sumaMid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		sumaMid = sumaProstihFaktora( a[ mid ] );
		
		if( sumaMid == s )
		{
			*element = a[ mid ];
			*index = mid;
			return;
		}
		else if( sumaMid < s )
			hi = mid - 1;
		else // sumaMid > s
			lo = mid + 1;
	}
	
	*index = -1;
}

/*
Podzadatak (b):
	int a[ 100 ], s, element, index;
	...
	grupaA( a, 100, s, &element, &index );
*/


// ---------------------------------------------------------------------------------------------------------- Grupa B
int sumaProstihFaktoraKratnost( int broj )
{
	int faktor = 2, suma = 0;
	
	while( broj > 1 )
	{
		while( broj % faktor == 0 )
		{
			suma += faktor;
			broj /= faktor;
		}
		
		++faktor;
	}
	
	return suma;
}

void grupaB( int b[], int n, int s, int *element, int *index )
{
	int lo = 0, hi = n-1, mid, sumaMid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		sumaMid = sumaProstihFaktoraKratnost( b[ mid ] );
		
		if( sumaMid == s )
		{
			*element = b[ mid ];
			*index = mid;
			return;
		}
		else if( sumaMid > s )
			hi = mid - 1;
		else // sumaMid < s
			lo = mid + 1;
	}
	
	*index = -1;
}

/*
Podzadatak (b):
	int b[ 200 ], s, element, index;
	...
	grupaB( b, 200, s, &element, &index );
*/


// ---------------------------------------------------------------------------------------------------------- Grupa C
int brojProstihFaktora( int broj )
{
	int faktor = 2, koliko = 0;
	
	while( broj > 1 )
	{
		if( broj % faktor == 0 )
		{
			++koliko;
			while( broj % faktor == 0 )
				broj /= faktor;
		}
		
		++faktor;
	}
	
	return koliko;
}

void grupaC( int c[], int n, int b, int *element, int *index )
{
	int lo = 0, hi = n-1, mid, kolikoMid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		kolikoMid = brojProstihFaktora( c[ mid ] );
		
		if( kolikoMid == b )
		{
			*element = c[ mid ];
			*index = mid;
			return;
		}
		else if( kolikoMid > b )
			hi = mid - 1;
		else // kolikoMid < b
			lo = mid + 1;
	}
	
	*index = -1;
}

/*
Podzadatak (b):
	int c[ 300 ], b, element, index;
	...
	grupaC( c, 300, b, &element, &index );
*/


// ---------------------------------------------------------------------------------------------------------- Grupa D
int brojProstihFaktoraKratnost( int broj )
{
	int faktor = 2, koliko = 0;
	
	while( broj > 1 )
	{
		while( broj % faktor == 0 )
		{
			++koliko;
			broj /= faktor;
		}
		
		++faktor;
	}
	
	return koliko;
}

void grupaD( int d[], int n, int p, int *element, int *index )
{
	int lo = 0, hi = n-1, mid, kolikoMid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		kolikoMid = brojProstihFaktoraKratnost( d[ mid ] );
		
		if( kolikoMid == p )
		{
			*element = d[ mid ];
			*index = mid;
			return;
		}
		else if( kolikoMid < p )
			hi = mid - 1;
		else // kolikoMid > p
			lo = mid + 1;
	}
	
	*index = -1;
}

/*
Podzadatak (b):
	int d[ 400 ], p, element, index;
	...
	grupaD( d, 400, p, &element, &index );
*/


// ---------------------------------------------------------------------------------------------------------- main (za provjeru, ne treba ga pisati u kolokviju)
int main( void )
{
	int poljeA[] = { 19, 7, 24, 3, 1 }, element, index;
	grupaA( poljeA, 5, 5, &element, &index );
	
	printf( "%d %d\n", element, index );

	int poljeB[] = { 1, 3, 7, 24, 19 };
	grupaB( poljeB, 5, 9, &element, &index );
	
	printf( "%d %d\n", element, index );

	int poljeC[] = { 1, 997, 48, 30, 420 };
	grupaC( poljeC, 5, 2, &element, &index );
	
	printf( "%d %d\n", element, index );

	int poljeD[] = { 420, 24, 30, 997, 1 };
	grupaD( poljeD, 5, 5, &element, &index );
	
	printf( "%d %d\n", element, index );

	return 0;
}
